#include <iostream>
#include <stdio.h>
#include <bcm2835.h>
#include <stdlib.h>
#include <time.h>
#include <unistd.h>

using namespace std;

#define SIG RPI_BPLUS_GPIO_J8_11 // Numéro de la broche sur le GPIO
#define clk_div BCM2835_I2C_CLOCK_DIVIDER_2500

// g++ -o MCP3427_2018_04_09d bcm2835.cpp MCP3427_2018_04_09d.cpp 


double getMesure(int CH) 
{

	int temp=0;
	double mesure = 0;
	char i2cOut[2];
	char i2cIn[3];

	if (CH==1) 		i2cOut[0]=0x88; 		// Mesure sur CH1
	else if (CH==2) 	i2cOut[0]=0xA8; 		// Mesure sur CH2
		bcm2835_i2c_write(i2cOut, 1); 		// Configuration en 16bits et mesure sur CH1+ ou CH2+ en one shoot (économie d'énergie)
		bcm2835_delay(100);				// Délais indispensable pour laisser le temps à la conversion
		bcm2835_i2c_read(i2cIn, 3);		// Lecture des 3 octets
		mesure = (256*i2cIn[0] + i2cIn[1])*2.048/32767;	// Calcul
		return mesure;
}



int main(void) 
{
	unsigned int slave_address=0x6C;

	if (!bcm2835_init() || !bcm2835_i2c_begin())
	{
		printf("init failed. Are you running as root??\n");
		_exit(-1);

	}
	bcm2835_i2c_setSlaveAddress(slave_address);
	bcm2835_i2c_setClockDivider(clk_div);

	while(1)
	{
		cout<<"Valeur de CH1+ = "<< getMesure(1)<<" V"<<endl;
		cout<<"Valeur de CH2+ = "<< getMesure(2)<<" V"<<endl;

		bcm2835_delay(2000);
		cout<<endl;
	}
		
	bcm2835_i2c_end();
	bcm2835_close();

	return 0;
}
